diff --git a/.gitignore b/.gitignore
index 3deab9509..da66d74a9 100644
--- a/.gitignore
+++ b/.gitignore
@@ -16,4 +16,5 @@
 src/main/java/net/minecraft/core/Version.java
 **.log
 BiomeLookup.png
-version.txt
\ No newline at end of file
+version.txt
+log4j.properties
diff --git a/build.gradle.kts b/build.gradle.kts
index 93a4bf8c8..153cb801a 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -147,11 +147,14 @@ dependencies {
 
     implementation("objects:client:43db9b498cb67058d2e12d394e6507722e71bb45") // Minecraft client jar
 
-    val log4jVersion = "2.20.0"
-    implementation("org.apache.logging.log4j:log4j-core:${log4jVersion}")?.let { serverInclude(it) }
-    implementation("org.apache.logging.log4j:log4j-api:${log4jVersion}")?.let { serverInclude(it) }
-    implementation("org.apache.logging.log4j:log4j-1.2-api:${log4jVersion}")?.let { serverInclude(it) }
-    implementation("log4j:apache-log4j-extras:1.2.17")?.let { serverInclude (it) }
+    implementation("com.formdev:flatlaf:3.1.1")?.let { clientInclude(it) } // Dark theme used by SeedViewer
+    
+    implementation("org.slf4j:slf4j-api:2.0.7")?.let { clientInclude(it); serverInclude(it) }
+
+    val log4jVersion = "2.19.0"
+    implementation("org.apache.logging.log4j:log4j-core:${log4jVersion}")?.let { clientInclude(it); serverInclude(it) }
+    implementation("org.apache.logging.log4j:log4j-api:${log4jVersion}")?.let { clientInclude(it); serverInclude(it) }
+    implementation("org.apache.logging.log4j:log4j-slf4j2-impl:${log4jVersion}")?.let { clientInclude(it); serverInclude(it) }
 
     runtimeOnly(sourceSets.getByName("common").output)?.let { clientInclude(it); serverInclude(it) }
 }
diff --git a/src/common/resources/lang/en_US/gui.lang b/src/common/resources/lang/en_US/gui.lang
index a04074ff7..03fe0ba6e 100644
--- a/src/common/resources/lang/en_US/gui.lang
+++ b/src/common/resources/lang/en_US/gui.lang
@@ -229,7 +229,7 @@ gui.options.page.debug.category.utility=Utilities
 gui.options.page.debug.category.settings=Settings
 gui.options.page.debug.category.test=Tests
 gui.options.page.debug.button.open.model_viewer=Open Model Viewer
-gui.options.page.debug.button.open.biome_finder=Open Biome Finder
+gui.options.page.debug.button.open.biome_finder=Open Seed Viewer
 gui.options.page.debug.button.open.datadumper=Run Data Dumper
 gui.options.page.debug.button.open.sound_test=Open Sound Test
 gui.options.page.debug.button.open.texture_viewer=Open Texture Viewer
@@ -246,7 +246,7 @@ gui.options.page.search.title=Search
 gui.sound_test.label.title=Sound Test
 gui.sound_test.label.repo=Sound Repository: %s
 gui.sound_test.label.id=ID: %s
-gui.sound_test.label.name=Name: %s
+gui.sound_test.label.subtitle=Subtitle: %s | %s
 gui.sound_test.label.url=URL: %s
 gui.sound_test.label.select_repo=Select Repo:
 gui.sound_test.label.select_entry=Select Entry:
diff --git a/src/common/resources/lang/en_US/options.lang b/src/common/resources/lang/en_US/options.lang
index 5f4904060..5ddc13e90 100644
--- a/src/common/resources/lang/en_US/options.lang
+++ b/src/common/resources/lang/en_US/options.lang
@@ -165,6 +165,7 @@ options.disableShaders=Disable Shaders
 options.loadAllSounds=Load All Sounds
 options.allowSoundOverrides=Allow Sound Overrides
 options.downloadSoundfiles=Download Sound Files
+options.subtitles=Subtitles
 
 options.tooltipStyle.default=Default
 options.tooltipStyle.modern=Modern
diff --git a/src/common/resources/lang/en_US/subtitles.lang b/src/common/resources/lang/en_US/subtitles.lang
index e69de29bb..3cb37f19b 100644
--- a/src/common/resources/lang/en_US/subtitles.lang
+++ b/src/common/resources/lang/en_US/subtitles.lang
@@ -0,0 +1,85 @@
+subtitles.mob.sheep=Sheep bleat
+subtitles.mob.chicken=Chicken clucking
+subtitles.mob.chicken.hurt=Chicken hurt
+subtitles.mob.chicken.plop=Chicken plop
+subtitles.mob.pig=Pig oinking
+subtitles.mob.pig.death=Pig death
+subtitles.mob.wolf.howl=Wolf howl
+subtitles.mob.wolf.panting=Wolf panting
+subtitles.mob.wolf.hurt=Wolf hurt
+subtitles.mob.wolf.bark=Wolf Bark
+subtitles.mob.wolf.growl=Wolf growl
+subtitles.mob.wolf.death=Wolf death
+subtitles.mob.wolf.whine=Wolf whine
+subtitles.mob.wolf.shake=Wolf shaking
+subtitles.mob.cow.hurt=Cow hurt
+subtitles.mob.cow=Cow mooing
+subtitles.mob.zombie=Zombie groans
+subtitles.mob.zombie.hurt=Zombie hurt
+subtitles.mob.zombie.death=Zombie death
+subtitles.mob.zombiepig.zpighurt=Zombie pigman hurt
+subtitles.mob.zombiepig.zpig=Zombie pigman groans
+subtitles.mob.zombiepig.zpigdeath=Zombie pigman death
+subtitles.mob.zombiepig.zpigangry=Zombie pigman angry
+subtitles.mob.skeleton=Skeleton rattles
+subtitles.mob.skeleton.death=Skeleton death
+subtitles.mob.skeleton.hurt=Skeleton hurt
+subtitles.mob.ghast.fireball=Ghast fireball
+subtitles.mob.ghast.moan=Ghast moan
+subtitles.mob.ghast.death=Ghast death
+subtitles.mob.ghast.scream=Ghast Scream
+subtitles.mob.ghast.affectionate_scream=Ghast affectionate scream
+subtitles.mob.creeper=Creeper hiss
+subtitles.mob.creeper.death=Creeper death
+subtitles.mob.spider.death=Spider death
+subtitles.mob.spider=Spider hiss
+subtitles.mob.ghast.charge=Ghast charging
+subtitles.mob.slime.attack=Slime attack
+subtitles.mob.slime=Slime plop
+
+subtitles.fall.small=Small fall
+subtitles.damage.fall.big=Big fall
+
+subtitles.liquid.water=Water flowing
+subtitles.liquid.lava.pop=Lava pop
+subtitles.liquid.lava=Lava bubbling
+subtitles.liquid.splash=Water splash
+
+subtitles.portal.portal=Portal ambience
+subtitles.portal.trigger=Portal trigger
+subtitles.portal.travel=Portal travel
+
+subtitles.random.fizz=Fizzing
+subtitles.random.drr=Arrow drr
+subtitles.random.fuse=Fuse lit
+subtitles.random.pop=Pop
+subtitles.random.glass=Glass
+subtitles.random.door_open=Door opened
+subtitles.random.door_close=Door closed
+subtitles.random.explode=Explosion
+subtitles.random.bow=Bow shot
+subtitles.random.hurt=Hurt
+subtitles.random.splash=Splash
+subtitles.random.breath=Breath
+subtitles.random.bite=Player Eating
+subtitles.random.equip=Armor Equipped
+
+subtitles.note.snare=Note snare
+subtitles.note.harp=Note harp
+subtitles.note.bass=Note bass
+subtitles.note.bd=Note bd
+subtitles.note.pling=Note pling
+subtitles.note.hat=Note hat
+subtitles.note.bassattack=Note bass attack
+
+subtitles.ambient.weather.thunder=Thunder
+subtitles.ambient.cave=Cave ambience
+subtitles.ambient.weather.rain=Rainfall
+
+subtitles.tile.piston.out=Piston extended
+subtitles.tile.piston.in=Piston retracted
+
+subtitles.hurt.flesh=Hurt flesh
+
+subtitles.fire.ignite=Fire lit
+subtitles.fire.fire=Fire crackling
diff --git a/src/main/java/com/b100/utils/FileUtils.java b/src/main/java/com/b100/utils/FileUtils.java
index 214ec3fb1..1f8f5eeda 100644
--- a/src/main/java/com/b100/utils/FileUtils.java
+++ b/src/main/java/com/b100/utils/FileUtils.java
@@ -9,6 +9,7 @@ import java.io.IOException;
 import java.io.InputStream;
 import java.io.OutputStream;
 import java.net.URL;
+import java.nio.file.Files;
 import java.util.ArrayList;
 import java.util.List;
 
@@ -132,8 +133,8 @@ public abstract class FileUtils {
 		try {
 			createNewFile(to);
 			
-			InputStream in = new FileInputStream(from);
-			OutputStream out = new FileOutputStream(to);
+			InputStream in = Files.newInputStream(from.toPath());
+			OutputStream out = Files.newOutputStream(to.toPath());
 			
 			StreamUtils.transferData(in, out);
 			
@@ -197,7 +198,7 @@ public abstract class FileUtils {
 		FileUtils.createNewFile(file);
 		
 		BufferedInputStream in = new BufferedInputStream(url.openStream());
-		BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(file));
+		BufferedOutputStream out = new BufferedOutputStream(Files.newOutputStream(file.toPath()));
 		
 		StreamUtils.transferDataAndClose(in, out);
 	}
diff --git a/src/main/java/com/b100/utils/ImageUtils.java b/src/main/java/com/b100/utils/ImageUtils.java
index cb50685b0..f506ce526 100644
--- a/src/main/java/com/b100/utils/ImageUtils.java
+++ b/src/main/java/com/b100/utils/ImageUtils.java
@@ -11,6 +11,8 @@ import java.awt.image.BufferedImage;
 import java.io.File;
 import java.io.FileInputStream;
 import java.io.IOException;
+import java.io.InputStream;
+import java.nio.file.Files;
 
 import javax.imageio.ImageIO;
 
@@ -34,9 +36,9 @@ public abstract class ImageUtils {
 			throw new RuntimeException("Not a file: "+file.getAbsolutePath());
 		}
 		
-		FileInputStream stream;
+		InputStream stream;
 		try {
-			stream = new FileInputStream(file);
+			stream = Files.newInputStream(file.toPath());
 		}catch (Exception e) {
 			throw new RuntimeException("Could not open file", e);
 		}
diff --git a/src/main/java/com/b100/utils/ReflectUtils.java b/src/main/java/com/b100/utils/ReflectUtils.java
index b0b7a0e5a..49874eb98 100644
--- a/src/main/java/com/b100/utils/ReflectUtils.java
+++ b/src/main/java/com/b100/utils/ReflectUtils.java
@@ -1,5 +1,7 @@
 package com.b100.utils;
 
+import net.minecraft.core.Global;
+
 import static com.b100.utils.Utils.*;
 
 import java.lang.reflect.Field;
diff --git a/src/main/java/com/b100/utils/StringUtils.java b/src/main/java/com/b100/utils/StringUtils.java
index 9394eee83..d7a0bc78a 100644
--- a/src/main/java/com/b100/utils/StringUtils.java
+++ b/src/main/java/com/b100/utils/StringUtils.java
@@ -7,6 +7,7 @@ import java.io.FileWriter;
 import java.io.InputStream;
 import java.io.InputStreamReader;
 import java.net.URL;
+import java.nio.file.Files;
 import java.util.List;
 
 public abstract class StringUtils {
@@ -21,7 +22,7 @@ public abstract class StringUtils {
 		FileUtils.validateFileExists(file);
 		
 		try{
-			return readInputString(new FileInputStream(file));
+			return readInputString(Files.newInputStream(file.toPath()));
 		}catch (Exception e) {
 			throw new RuntimeException("Error while reading file", e);
 		}
diff --git a/src/main/java/com/mojang/logging/LogQueues.java b/src/main/java/com/mojang/logging/LogQueues.java
new file mode 100644
index 000000000..9c9d625c9
--- /dev/null
+++ b/src/main/java/com/mojang/logging/LogQueues.java
@@ -0,0 +1,54 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package com.mojang.logging;
+
+import org.jetbrains.annotations.Nullable;
+
+import java.util.HashMap;
+import java.util.concurrent.LinkedBlockingQueue;
+import java.util.concurrent.locks.ReentrantReadWriteLock;
+import java.util.concurrent.BlockingQueue;
+import java.util.Map;
+
+public class LogQueues
+{
+    private static final Map<String, BlockingQueue<String>> QUEUES = new HashMap<>();
+    private static final ReentrantReadWriteLock QUEUE_LOCK = new ReentrantReadWriteLock();
+    
+    public static BlockingQueue<String> getOrCreateQueue(final String target) {
+        try {
+            LogQueues.QUEUE_LOCK.readLock().lock();
+            final BlockingQueue<String> queue = LogQueues.QUEUES.get(target);
+            if (queue != null) {
+                return queue;
+            }
+        }
+        finally {
+            LogQueues.QUEUE_LOCK.readLock().unlock();
+        }
+        try {
+            LogQueues.QUEUE_LOCK.writeLock().lock();
+            return LogQueues.QUEUES.computeIfAbsent(target, k -> new LinkedBlockingQueue<>());
+        }
+        finally {
+            LogQueues.QUEUE_LOCK.writeLock().unlock();
+        }
+    }
+    
+    @Nullable
+    public static String getNextLogEvent(final String queueName) {
+        LogQueues.QUEUE_LOCK.readLock().lock();
+        final BlockingQueue<String> queue = LogQueues.QUEUES.get(queueName);
+        LogQueues.QUEUE_LOCK.readLock().unlock();
+        if (queue != null) {
+            try {
+                return queue.take();
+            }
+            catch (final InterruptedException ignored) {}
+        }
+        return null;
+    }
+
+}
diff --git a/src/main/java/com/mojang/logging/LogUtils.java b/src/main/java/com/mojang/logging/LogUtils.java
new file mode 100644
index 000000000..521a5ab35
--- /dev/null
+++ b/src/main/java/com/mojang/logging/LogUtils.java
@@ -0,0 +1,89 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package com.mojang.logging;
+
+import org.slf4j.MarkerFactory;
+import org.slf4j.LoggerFactory;
+import org.slf4j.Logger;
+import java.util.function.Supplier;
+import org.apache.logging.log4j.core.config.LoggerConfig;
+import org.apache.logging.log4j.core.config.Configuration;
+import org.slf4j.event.Level;
+import org.apache.logging.log4j.spi.LoggerContext;
+import org.apache.logging.log4j.core.LifeCycle;
+import org.apache.logging.log4j.LogManager;
+import org.slf4j.Marker;
+
+public class LogUtils
+{
+    public static final String FATAL_MARKER_ID = "FATAL";
+    public static final Marker FATAL_MARKER = MarkerFactory.getMarker(FATAL_MARKER_ID);
+//    private static final StackWalker STACK_WALKER = StackWalker.getInstance(StackWalker.Option.RETAIN_CLASS_REFERENCE);
+    
+    public static boolean isLoggerActive() {
+        final LoggerContext loggerContext = LogManager.getContext();
+        if (loggerContext instanceof LifeCycle) {
+            LifeCycle lifeCycle = (LifeCycle) loggerContext;
+            return !lifeCycle.isStopped();
+        }
+        return true;
+    }
+    
+    public static void configureRootLoggingLevel(final Level level) {
+        final org.apache.logging.log4j.core.LoggerContext ctx = (org.apache.logging.log4j.core.LoggerContext)LogManager.getContext(false);
+        final Configuration config = ctx.getConfiguration();
+        final LoggerConfig loggerConfig = config.getLoggerConfig("");
+        loggerConfig.setLevel(convertLevel(level));
+        ctx.updateLoggers();
+    }
+    
+    private static org.apache.logging.log4j.Level convertLevel(final Level level) {
+        switch (level) {
+            case INFO:
+                return org.apache.logging.log4j.Level.INFO;
+            case WARN:
+                return org.apache.logging.log4j.Level.WARN;
+            case DEBUG:
+                return org.apache.logging.log4j.Level.DEBUG;
+            case ERROR:
+                return org.apache.logging.log4j.Level.ERROR;
+            case TRACE:
+                return org.apache.logging.log4j.Level.TRACE;
+            default:
+                throw new IncompatibleClassChangeError();
+        }
+    }
+    
+    public static Object defer(final Supplier<Object> result) {
+        class ToString
+        {
+            @Override
+            public String toString() {
+                return result.get().toString();
+            }
+        }
+        return new ToString();
+    }
+    
+    public static Logger getLogger() {
+        return LoggerFactory.getLogger(getCallerClass());
+    }
+
+    private static Class<?> getCallerClass() { // Hacky way to replace the STACK_WALKER since STACK_WALKER uses java 9 language features
+        try {
+            StackTraceElement[] stElements = Thread.currentThread().getStackTrace();
+            for (int i=1; i<stElements.length; i++) {
+                StackTraceElement ste = stElements[i];
+                if (!ste.getClassName().equals(LogUtils.class.getName()) && ste.getClassName().indexOf("java.lang.Thread")!=0) {
+                    return Class.forName(ste.getClassName());
+                }
+            }
+        } catch (ClassNotFoundException notFoundException) {
+            System.err.print("Could not find calling class!");
+        }
+        return LogUtils.class;
+    }
+
+}
diff --git a/src/main/java/com/mojang/logging/annotations/FieldsAreNonnullByDefault.java b/src/main/java/com/mojang/logging/annotations/FieldsAreNonnullByDefault.java
new file mode 100644
index 000000000..28ea0f259
--- /dev/null
+++ b/src/main/java/com/mojang/logging/annotations/FieldsAreNonnullByDefault.java
@@ -0,0 +1,14 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package com.mojang.logging.annotations;
+
+import java.lang.annotation.RetentionPolicy;
+import java.lang.annotation.Retention;
+
+//@Nonnull
+//@TypeQualifierDefault({ ElementType.FIELD })
+@Retention(RetentionPolicy.RUNTIME)
+public @interface FieldsAreNonnullByDefault {
+}
diff --git a/src/main/java/com/mojang/logging/annotations/MethodsReturnNonnullByDefault.java b/src/main/java/com/mojang/logging/annotations/MethodsReturnNonnullByDefault.java
new file mode 100644
index 000000000..3b35754cb
--- /dev/null
+++ b/src/main/java/com/mojang/logging/annotations/MethodsReturnNonnullByDefault.java
@@ -0,0 +1,14 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package com.mojang.logging.annotations;
+
+import java.lang.annotation.RetentionPolicy;
+import java.lang.annotation.Retention;
+
+//@Nonnull
+//@TypeQualifierDefault({ ElementType.METHOD })
+@Retention(RetentionPolicy.RUNTIME)
+public @interface MethodsReturnNonnullByDefault {
+}
diff --git a/src/main/java/com/mojang/logging/plugins/LegacyXMLLayout.java b/src/main/java/com/mojang/logging/plugins/LegacyXMLLayout.java
new file mode 100644
index 000000000..d4dcc1ed2
--- /dev/null
+++ b/src/main/java/com/mojang/logging/plugins/LegacyXMLLayout.java
@@ -0,0 +1,250 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package com.mojang.logging.plugins;
+
+import org.apache.logging.log4j.core.config.plugins.PluginFactory;
+import org.apache.logging.log4j.core.config.plugins.PluginAttribute;
+import org.apache.logging.log4j.Marker;
+import org.apache.logging.log4j.Level;
+import java.util.HashMap;
+import java.util.List;
+import org.apache.logging.log4j.message.Message;
+import java.util.Map;
+import org.apache.logging.log4j.core.util.Throwables;
+import org.apache.logging.log4j.message.MultiformatMessage;
+import org.apache.logging.log4j.core.util.Transform;
+import org.apache.logging.log4j.core.LogEvent;
+import org.apache.logging.log4j.util.Strings;
+import java.nio.charset.Charset;
+import org.apache.logging.log4j.core.config.plugins.Plugin;
+import org.apache.logging.log4j.core.layout.AbstractStringLayout;
+
+@Plugin(name = "LegacyXMLLayout", category = "Core", elementType = "layout", printObject = true)
+public class LegacyXMLLayout extends AbstractStringLayout
+{
+    private static final String XML_NAMESPACE = "http://logging.apache.org/log4j/2.0/events";
+    private static final String ROOT_TAG = "Events";
+    private static final int DEFAULT_SIZE = 256;
+    private static final String DEFAULT_EOL = "\r\n";
+    private static final String COMPACT_EOL = "";
+    private static final String DEFAULT_INDENT = "  ";
+    private static final String COMPACT_INDENT = "";
+    private static final String DEFAULT_NS_PREFIX = "log4j";
+    private static final String[] FORMATS = new String[] { "xml" };
+    private final boolean locationInfo;
+    private final boolean properties;
+    private final boolean complete;
+    private final String namespacePrefix;
+    private final String eol;
+    private final String indent1;
+    private final String indent2;
+    private final String indent3;
+    
+    protected LegacyXMLLayout(final boolean locationInfo, final boolean properties, final boolean complete, final boolean compact, final String nsPrefix, final Charset charset) {
+        super(charset);
+        this.locationInfo = locationInfo;
+        this.properties = properties;
+        this.complete = complete;
+        this.eol = (compact ? COMPACT_EOL : DEFAULT_EOL);
+        this.indent1 = (compact ? COMPACT_INDENT : DEFAULT_INDENT);
+        this.indent2 = this.indent1 + this.indent1;
+        this.indent3 = this.indent2 + this.indent1;
+        this.namespacePrefix = (Strings.isEmpty(nsPrefix) ? DEFAULT_NS_PREFIX : nsPrefix);
+    }
+    
+    public String toSerializable(final LogEvent event) {
+        final StringBuilder buf = new StringBuilder(DEFAULT_SIZE);
+        buf.append(this.indent1);
+        buf.append('<');
+        if (!this.complete) {
+            buf.append(this.namespacePrefix);
+        }
+        buf.append("Event logger=\"");
+        String name = event.getLoggerName();
+        if (name.isEmpty()) {
+            name = "root";
+        }
+        buf.append(Transform.escapeHtmlTags(name));
+        buf.append("\" timestamp=\"");
+        buf.append(event.getTimeMillis());
+        buf.append("\" level=\"");
+        buf.append(Transform.escapeHtmlTags(getEventLevel(event)));
+        buf.append("\" thread=\"");
+        buf.append(Transform.escapeHtmlTags(event.getThreadName()));
+        buf.append("\">");
+        buf.append(this.eol);
+        final Message msg = event.getMessage();
+        if (msg != null) {
+            boolean xmlSupported = false;
+            if (msg instanceof MultiformatMessage) {
+                final String[] formats2 = ((MultiformatMessage) msg).getFormats();
+                for (final String format : formats2) {
+                    if (format.equalsIgnoreCase("XML")) {
+                        xmlSupported = true;
+                        break;
+                    }
+                }
+            }
+            buf.append(this.indent2);
+            buf.append('<');
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("Message>");
+            if (xmlSupported) {
+                buf.append(((MultiformatMessage)msg).getFormattedMessage(LegacyXMLLayout.FORMATS));
+            }
+            else {
+                buf.append("<![CDATA[");
+                Transform.appendEscapingCData(buf, event.getMessage().getFormattedMessage());
+                buf.append("]]>");
+            }
+            buf.append("</");
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("Message>");
+            buf.append(this.eol);
+        }
+        if (event.getContextStack().getDepth() > 0) {
+            buf.append(this.indent2);
+            buf.append('<');
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("NDC><![CDATA[");
+            Transform.appendEscapingCData(buf, event.getContextStack().toString());
+            buf.append("]]></");
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("NDC>");
+            buf.append(this.eol);
+        }
+        final Throwable throwable = event.getThrown();
+        if (throwable != null) {
+            final List<String> s = Throwables.toStringList(throwable);
+            buf.append(this.indent2);
+            buf.append('<');
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("Throwable><![CDATA[");
+            for (final String str : s) {
+                Transform.appendEscapingCData(buf, str);
+                buf.append(this.eol);
+            }
+            buf.append("]]></");
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("Throwable>");
+            buf.append(this.eol);
+        }
+        if (this.locationInfo) {
+            final StackTraceElement element = event.getSource();
+            buf.append(this.indent2);
+            buf.append('<');
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("LocationInfo class=\"");
+            buf.append(Transform.escapeHtmlTags(element.getClassName()));
+            buf.append("\" method=\"");
+            buf.append(Transform.escapeHtmlTags(element.getMethodName()));
+            buf.append("\" file=\"");
+            buf.append(Transform.escapeHtmlTags(element.getFileName()));
+            buf.append("\" line=\"");
+            buf.append(element.getLineNumber());
+            buf.append("\"/>");
+            buf.append(this.eol);
+        }
+        if (this.properties && event.getContextMap().size() > 0) {
+            buf.append(this.indent2);
+            buf.append('<');
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("Properties>");
+            buf.append(this.eol);
+            for (final Map.Entry<String, String> entry : event.getContextMap().entrySet()) {
+                buf.append(this.indent3);
+                buf.append('<');
+                if (!this.complete) {
+                    buf.append(this.namespacePrefix);
+                }
+                buf.append("Data name=\"");
+                buf.append(Transform.escapeHtmlTags(entry.getKey()));
+                buf.append("\" value=\"");
+                buf.append(Transform.escapeHtmlTags(String.valueOf(entry.getValue())));
+                buf.append("\"/>");
+                buf.append(this.eol);
+            }
+            buf.append(this.indent2);
+            buf.append("</");
+            if (!this.complete) {
+                buf.append(this.namespacePrefix);
+            }
+            buf.append("Properties>");
+            buf.append(this.eol);
+        }
+        buf.append(this.indent1);
+        buf.append("</");
+        if (!this.complete) {
+            buf.append(this.namespacePrefix);
+        }
+        buf.append("Event>");
+        buf.append(this.eol);
+        return buf.toString();
+    }
+    
+    public byte[] getHeader() {
+        if (!this.complete) {
+            return null;
+        }
+        final StringBuilder buf = new StringBuilder();
+        buf.append("<?xml version=\"1.0\" encoding=\"");
+        buf.append(this.getCharset().name());
+        buf.append("\"?>");
+        buf.append(this.eol);
+        buf.append('<');
+        buf.append(ROOT_TAG);
+        buf.append(" xmlns=\"" + XML_NAMESPACE + "\">");
+        buf.append(this.eol);
+        return buf.toString().getBytes(this.getCharset());
+    }
+    
+    public byte[] getFooter() {
+        if (!this.complete) {
+            return null;
+        }
+        return ("</" + ROOT_TAG + ">" + this.eol).getBytes(this.getCharset());
+    }
+    
+    public Map<String, String> getContentFormat() {
+        final Map<String, String> result = new HashMap<String, String>();
+        result.put("xsd", "log4j-events.xsd");
+        result.put("version", "2.0");
+        return result;
+    }
+    
+    public String getContentType() {
+        return "text/xml; charset=" + this.getCharset();
+    }
+    
+    private static String getEventLevel(final LogEvent event) {
+        final Marker marker = event.getMarker();
+        if (marker != null && marker.isInstanceOf("FATAL")) {
+            return String.valueOf(Level.FATAL);
+        }
+        return String.valueOf(event.getLevel());
+    }
+    
+    @PluginFactory
+    public static LegacyXMLLayout createLayout(@PluginAttribute("locationInfo") final boolean locationInfo, @PluginAttribute("properties") final boolean properties, @PluginAttribute("complete") final boolean completeStr, @PluginAttribute("compact") final boolean compactStr, @PluginAttribute("namespacePrefix") final String namespacePrefix, @PluginAttribute(value = "charset", defaultString = "UTF-8") final Charset charset) {
+        return new LegacyXMLLayout(locationInfo, properties, completeStr, compactStr, namespacePrefix, charset);
+    }
+
+}
diff --git a/src/main/java/com/mojang/logging/plugins/QueueLogAppender.java b/src/main/java/com/mojang/logging/plugins/QueueLogAppender.java
new file mode 100644
index 000000000..0d1605c67
--- /dev/null
+++ b/src/main/java/com/mojang/logging/plugins/QueueLogAppender.java
@@ -0,0 +1,57 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package com.mojang.logging.plugins;
+
+import org.apache.logging.log4j.core.config.plugins.PluginFactory;
+import org.apache.logging.log4j.core.layout.PatternLayout;
+import com.mojang.logging.LogQueues;
+import org.apache.logging.log4j.core.config.plugins.PluginElement;
+import org.apache.logging.log4j.core.config.plugins.PluginAttribute;
+import org.apache.logging.log4j.core.LogEvent;
+import java.io.Serializable;
+import org.apache.logging.log4j.core.Layout;
+import org.apache.logging.log4j.core.Filter;
+import java.util.concurrent.BlockingQueue;
+import org.apache.logging.log4j.core.config.plugins.Plugin;
+import org.apache.logging.log4j.core.appender.AbstractAppender;
+
+@Plugin(name = "Queue", category = "Core", elementType = "appender", printObject = true)
+public class QueueLogAppender extends AbstractAppender
+{
+    private static final int MAX_CAPACITY = 250;
+    private final BlockingQueue<String> queue;
+    
+    public QueueLogAppender(final String name, final Filter filter, final Layout<? extends Serializable> layout, final boolean ignoreExceptions, final BlockingQueue<String> queue) {
+        super(name, filter, layout, ignoreExceptions);
+        this.queue = queue;
+    }
+    
+    public void append(final LogEvent event) {
+        if (this.queue.size() >= MAX_CAPACITY) {
+            this.queue.clear();
+        }
+        this.queue.add(this.getLayout().toSerializable(event).toString());
+    }
+    
+    @PluginFactory
+    public static QueueLogAppender createAppender(@PluginAttribute("name") final String name, @PluginAttribute("ignoreExceptions") final String ignore, @PluginElement("Layout") Layout<? extends Serializable> layout, @PluginElement("Filters") final Filter filter, @PluginAttribute("target") final String target) {
+        final boolean ignoreExceptions = Boolean.parseBoolean(ignore);
+        if (name == null) {
+            QueueLogAppender.LOGGER.error("No name provided for QueueLogAppender");
+            return null;
+        }
+        final BlockingQueue<String> queue = LogQueues.getOrCreateQueue(requireNonNullElse(target, name));
+        if (layout == null) {
+            layout = PatternLayout.newBuilder().build();
+        }
+        return new QueueLogAppender(name, filter, layout, ignoreExceptions, queue);
+    }
+
+    private static <T> T requireNonNullElse(T obj, T defaultObj) {
+        if (obj != null) return obj;
+        if (defaultObj != null) return defaultObj;
+        throw new NullPointerException("defaultObj");
+    }
+}
diff --git a/src/main/java/com/mojang/nbt/LongArrayTag.java b/src/main/java/com/mojang/nbt/LongArrayTag.java
new file mode 100644
index 000000000..8042bdea3
--- /dev/null
+++ b/src/main/java/com/mojang/nbt/LongArrayTag.java
@@ -0,0 +1,45 @@
+package com.mojang.nbt;
+
+import java.io.DataInput;
+import java.io.DataOutput;
+import java.io.IOException;
+import java.nio.ByteBuffer;
+import java.nio.ByteOrder;
+
+public class LongArrayTag extends Tag<long[]>{
+    public LongArrayTag()
+    {
+        setValue(new long[0]);
+    }
+
+    public LongArrayTag(long[] array)
+    {
+        super(array);
+    }
+    @Override
+    void write(DataOutput dos)
+        throws IOException
+    {
+        dos.writeInt(getValue().length);
+        byte[] bytes = new byte[getValue().length * 4];
+        ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asLongBuffer().put(getValue());
+        dos.write(bytes);
+
+    }
+
+    @Override
+    void read(DataInput dis)
+        throws IOException
+    {
+        int length = dis.readInt();
+        setValue(new long[length]);
+        byte[] bytes = new byte[length * 4];
+        dis.readFully(bytes);
+        ByteBuffer.wrap(bytes).order(ByteOrder.LITTLE_ENDIAN).asLongBuffer().get(getValue());
+    }
+
+    @Override
+    public byte getId() {
+        return 13;
+    }
+}
